#include "descriptor/descriptor.h"

int main(void) {

  ITEM	glass, brown, green, gray, metal,standard;

  ITEM	scene;
  ITEM  front, paretesx, floor, paretedx, sofitto,vetro;
  //ITEM  vetro, bed, finestra, tovaglia, cuscinoletto, cuscinoletto2, coperta, cuscino_sedia, cuscino_sedia_letto;
  //ITEM  quadrolungo, dipintolungo, quadrolargo, dipintolargo, quadro1, dipinto1, quadro2, dipinto2;

  ITEM  poltrona1,poltrona2,poltrona_piedi1,poltrona_piedi2,tavolino, finestra, vaso, frutti, cuscino;



  char * texture_muro = "textures/muro.hr";
  char * texture_pavimento = "textures/pav.hr";
  char * texture_cornice = "textures/wood_cornice.hr";
  char * texture_frutti = "textures/frutto.hr";
  char * texture_vaso = "textures/BlueSkin.hr";
  char * texture_poltrona = "textures/StoffaRossa.hr";
  char * texture_cuscino = "textures/stoffa_cuscino.hr";

  set_background(0,0,0,TRUE);
  set_ambient_light(1,1,1,0.9);
  //create_point_light(25.16,15.90,9.39,1,1,1,3.89,20, "light1");
  //create_point_light(20,0, 9,1, 1, 1, 4, 20, "light2");
  create_point_light(-20.0,1.85,2.5,1,1,1,2.0,25, "light");

  // ATTRIBUTE glass

  glass = create_attribute("glass");
  set_color(glass,0.68,0.86,1,0.5,0.5);
  set_reflectivity(glass,0.24,2);
  set_transparency(glass,0.87,0.68,1,1.2);



  // ATTRIBUTE brown
  brown = create_attribute("brown");
  set_color(brown,0.93,0.23,0.03,0.2,0.8);
  set_reflectivity(brown,0.17,15);


   // ATTRIBUTE
  green = create_attribute("green");
  set_reflectivity(green,0.3,10);
  set_color(green,0.04,0.4,0,0.1,0.3);

  //ATTRIBUTE gray
  gray = create_attribute("gray");
  set_color(gray,1,1,1,0.5,0.0);

  metal = create_attribute("metal");
  set_reflectivity(metal,0.8,10);
  set_color(metal,0.22,0.22,0.22,0.5,0.5);


  // ATTRIBUTE standard

  standard = create_attribute("standard");
  set_color(standard,1,1,1,0,1);
  set_reflectivity(standard,0,2);
  set_transparency(standard,0,0,0,1);


  /* ---COSTRUZIONE DELLA SCENA---*/

  /* poltrona*/


  poltrona1 = read_obj("poltrona.obj", "poltrona1");
  set_scale(poltrona1,1.5,1.5,1.5);
  set_translate(poltrona1,-22,-3.5,-2.8);
  set_domain_texture(poltrona1,standard, texture_poltrona, 0, 1, 0, 1, 1, 0.6, 0.6);


  poltrona2 = create_copy(poltrona1, "poltrona2");
  set_translate(poltrona2,0, 11,0);




  poltrona_piedi1 = read_obj("poltrona_piedi.obj", "poltrona_piedi1");
  set_scale(poltrona_piedi1,1.5,1.5,1.5);
  set_translate(poltrona_piedi1,-22,-3.5,-2.8);
  set_attribute(poltrona_piedi1, brown);



  poltrona_piedi2 = create_copy(poltrona_piedi1, "poltrona_piedi2");
  set_translate(poltrona_piedi2,0, 11,0);



  tavolino = read_obj("tavolino.obj", "tavolino");
   set_scale(tavolino,2,2,2);
  set_translate(tavolino,-16,1.85,-5.22);
 set_attribute(tavolino, metal);

  //set_domain_texture(tavolino,standard, texture_pavimento, 0, 1, 0, 1, 1, 0.6, 0.6);

  finestra = read_obj("finestra.obj", "finestra");
  set_scale(finestra,1.5,1.5,1.5);
  set_translate(finestra,-33.2,-7.5,-2);

  set_domain_texture(finestra,standard, texture_cornice, 0, 1, 0, 1, 1, 0.6, 0.6);


  vetro = read_nurbs("vetro.db");
  set_scale(vetro,1.5,1.5,1.5);
  set_translate(vetro,-32.8,-7.5,-1.40);
  set_attribute(vetro, glass);


  frutti = read_obj("vaso_frutti.obj", "frutti");
  set_scale(frutti,3,3,3);
  set_translate(frutti,-16.3,1.8,-5.65);
  set_domain_texture(frutti,standard, texture_frutti, 0, 1, 0, 1, 1, 0.6, 0.6);
  //set_attribute(frutti, green);

  vaso = read_nurbs("vaso.db");
  set_scale(vaso,3,3,3);
  set_translate(vaso,-16.3,1.8,-5.72);
  set_domain_texture(vaso,standard, texture_vaso, 0, 1, 0, 1, 1, 0.6, 0.6);
  
  
  
  
  
  cuscino = read_obj("cuscino.obj", "cuscino");
  set_scale(cuscino,1.5,1.5,1.5);
  set_z_rotate(cuscino,-10,1);
  set_translate(cuscino,-20.5,8.8,-4.2);
  set_domain_texture(cuscino,standard, texture_cuscino, 0, 1, 0, 1, 1, 0.6, 0.6);
  
  
  
  
  
  floor = read_nurbs("floor.db");
  set_scale(floor,2.3,2.3,2.3);
  set_translate(floor,-3,0,-1.742);
  set_domain_texture(floor,standard, texture_pavimento, 0, 1, 0, 1, 1, 0.6, 0.6);
    
  sofitto = read_nurbs("floor.db");
  set_scale(sofitto,2.3,2.3,2.3);
  set_x_rotate(sofitto,180,1);  
  set_translate(sofitto,2.000,-0.400,17.237);
  set_attribute(sofitto, gray);

  paretedx = read_nurbs("parete.db");
  //set_scale(paretedx,1,1,1.4);  
  set_translate(paretedx,0,0,0);
  set_domain_texture(paretedx,standard, texture_muro, 0, 1, 0, 1, 1, 0.6, 0.6);
  set_scale(paretedx,2.3,2.3,2.3);
  
  front = read_nurbs("parete.db");
  //set_scale(front,2.3,2.3,1);
  set_domain_texture(front,standard, texture_muro, 0, 1, 0, 1, 1, 0.6, 0.6);
  set_z_rotate(front,90,1);
  set_scale(front,2.3,2.3,2.3);
  //set_translate(front,-14.900,-2.400,5.457);

  paretesx = read_nurbs("parete.db");
  //set_scale(paretesx,1,1,1.4);
  set_domain_texture(paretesx,standard, texture_muro, 0, 1, 0, 1, 1, 0.6, 0.6);
  set_translate(paretesx,0,-26,0);
  /* -- L'inserimento degli oggetti nella scena -- */
  set_scale(paretesx,2.3,2.3,2.3);
  
  
 // scene = create_list(floor, "scene");
  scene = create_list(poltrona1, "scene");
  
  
  scene = insert_in_list(scene,poltrona2);
  scene = insert_in_list(scene,poltrona_piedi1);
  scene = insert_in_list(scene,poltrona_piedi2);  
  
  
  
  
 scene = insert_in_list(scene, tavolino);
 scene = insert_in_list(scene,vaso);  
 scene = insert_in_list(scene,frutti);  
 scene = insert_in_list(scene,finestra);
 scene = insert_in_list(scene,vetro);
 scene = insert_in_list(scene,cuscino); 
 scene = insert_in_list(scene, paretesx);
 scene = insert_in_list(scene,paretedx);  
 scene = insert_in_list(scene,floor);
 scene = insert_in_list(scene,sofitto);
 scene = insert_in_list(scene,front);


  save_scene("tworedchairs1.md","prova",scene);
  return(0);
}
